`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   23:28:18 07/06/2007
// Design Name:   memory_mapped_registers
// Module Name:   /home/lange/Desktop/u8_a2/tb_memory_mapped_registers.v
// Project Name:  u8_a2
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: memory_mapped_registers
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module tb_memory_mapped_regs_v;

  // Inputs
  reg CLK;
  reg RESET;
  reg [7:0] ADDR;
  reg [31:0] DATA_IN;
  reg WE;

  // Outputs
  wire [31:0] DATA_OUT;

  integer i;

  // Instantiate the Unit Under Test (UUT)
  memory_mapped_regs uut (
    .CLK(CLK), 
    .RESET(RESET), 
    .ADDR(ADDR), 
    .DATA_IN(DATA_IN), 
    .WE(WE), 
    .DATA_OUT(DATA_OUT)
  );

  // Erzeuge einen Taktzyklus
  task DoClockCycle;
    begin
      #10;
      CLK = 1;
      #10;
      CLK = 0;
    end
  endtask

  // Alle Signale ausgeben bei
  // Aenderung von DATA_OUT
  always @(DATA_OUT)
    $display("ADDR=%h DATA_OUT=%1d", ADDR, DATA_OUT);

  initial begin
    // Initialize Inputs
    CLK = 0;
    RESET = 0;
    ADDR = 0;
    DATA_IN = 0;
    WE = 0;

    // Wait 100 ns for global reset to finish
    #100;
        
    // Add stimulus here
    // Reset
    RESET = 1;
    DoClockCycle;
    RESET = 0;

    // Ueberstreiche ganzen Adressraum
    // und finde Registerleseadressen
    $display("Finde Registeradressen:");
    for (i = 0; i < 2**8; i = i + 1) begin
      ADDR = i; #1;
    end

    // Erzeuge Transaktionen der Waveform
    $display("Erzeuge Transaktionen:");
    WE = 1;
    ADDR = 8'h57; DATA_IN = 1002;
    DoClockCycle;
    ADDR = 8'hA9; DATA_IN = 78;
    DoClockCycle;
    ADDR = 8'h11; DATA_IN = 6304;
    DoClockCycle;
    ADDR = 8'h04; DATA_IN = 1194;
    DoClockCycle;
    ADDR = 8'h93; DATA_IN = 1234;
    DoClockCycle;
    WE = 0;
    DoClockCycle;
    WE = 1;
    ADDR = 8'h3F; DATA_IN = 4321;
    DoClockCycle;
    ADDR = 8'h2C; DATA_IN = 1234;
    DoClockCycle;
    $display("A=%0d B=%0d C=%0d D=%0d E=%0d F=%0d G=%0d",
             uut.A, uut.B, uut.C, uut.D, uut.E, uut.F, uut.G);
    $stop;
  end
      
endmodule

